// #autoload
// #name = _ZKillEvent
// #category = ZephyrFox's Scripts
// #description = Modifies the way damage/kill/death/destruction events are handled.
// #version = 1.0
// #date = 09.10.2003
// #status = finished
// #author = Anthony Vrabel
// #warrior = ZephyrFox
// #email = ZephyrFox@hotmail.com
// #web = www.zephyrfox.com
// #credits = ilys for the HUD code.
// #readme =
// #config =
// #include = support/callback.cs
// #include = support/mute_tools.cs
// #include = support/kill_callbacks.cs
// #include = support/team_tracker.cs
// #include = support/mission_callbacks.cs

if(!isObject(ZKE))
{
	new ScriptObject(ZKE)
	{
		class 	= ZKE;
		version = "1.0";
	};
}

package ZKEoverloads
{
	function defaultMessageCallback(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10)
	{
		$ZKEvictimName = deTag(%a1);
		$ZKEgender = deTag(%a2);
		$ZKEkillerName = deTag(%a4);

		Parent::DefaultMessageCallback(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
	}

	function clientCmdTeamDestroyMessage(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6) // Handles your team destroying NME shit and vehicles.
	{
		%string = deTag(%msgString);

		%destroyerName = deTag(%a1);
		%destroyed = deTag(%a2);

		if(deTag(%msgType) !$= "msgVehDestroyed")
		{
			if(Strstr(%string, "Generator") !$= -1) 		%dest = "a generator";
			else if(Strstr(%string, "Solar") !$= -1) 		%dest = "a solar panel";
			else if(Strstr(%string, "Pulse") !$= -1) 		%dest = "a sensor";
			else if(Strstr(%string, "Base") !$= -1) 		%dest = "a turret";
			else if(Strstr(%string, "Inventory") !$= -1) 		%dest = "an inventory station";
			else if(Strstr(%string, "Vehicle") !$= -1) 		%dest = "a vehicle station";
			else if(Strstr(%string, "Sentry") !$= -1) 		%dest = "a sentry turret";
			else if(Strstr(%string, "Deployed Sensor") !$= -1) 	%dest = "a deployable sensor";
			else if(Strstr(%string, "Deployed Spider") !$= -1) 	%dest = "a deployable clamp turret";
			else if(Strstr(%string, "Deployed Landspike") !$= -1) 	%dest = "a deployable spike turret";
			else if(Strstr(%string, "MPB Teleport") !$= -1) 	%dest = "a MPB teleport station";
			else %dest = "a " @ %destroyed;
		}

		if(teamTracker.getPlayerTeamID(%destroyerName,1) $= teamTracker.friendlyTeamID) %color = "<color:00c800>";
		else %color = "<color:c80000>";

		%destroyerName = stripColor(%destroyerName);

		%msg = %color @ %destroyerName @ " destroyed " @ %dest @ ".<spop>";

		ZKE.addHudLine(%msg);
		KillEventHUD.setVisible(1);
		if(isEventPending($KillEventHUD)) cancel($KillEventHUD);
		$KillEventHUD = KillEventHUD.schedule(7000, setVisible, 0);
	}

	function OptionsDlg::onWake(%this)
	{
		if (!$ZKEtoggle)
		{
			$RemapName[$RemapCount] = "\c5Zeph ZKE HUD";
			$RemapCmd[$RemapCount] = "ZKEHUDToggle";
			$RemapCount++;
			$ZKEtoggle = true;
		}

		parent::onWake(%this);
	}
};
if(isActivePackage(ZKEoverloads)) deactivatePackage(ZKEoverloads);
activatePackage(ZKEoverloads);

function ZKEHUDToggle(%val)
{
	if(!%val) KillEventHUD.setVisible(0);
	else KillEventHUD.setVisible(1);
}

function stripColor(%var)
{
	return stripChars(deTag(%var), "\cp\co\c1\c2\c3\c4\c5\c6\c7\c8\c9");
}

function ZKE::setup(%this)
{
	callback.add(onUserClientJoin, "ZKE.clearHudInfo");
	callback.add(onUserClientDrop, "ZKE.clearHudInfo");
	callback.add(onMatchStart, "ZKE.clearHudInfo");

	callback.add(CallbackmsgVehicleTeamDestroy,"ZKE.TKVDestroyed");
	callback.add(CallbackmsgVehicleDestroy,"ZKE.VDestroyed");
	callback.add(CallbackmsgVehicleScore,"ZKE.VScore");
	callback.add(CallbackmsgVehicleCrash, "ZKE.VCrash");

	callback.add(KillCallback,"ZKE.KillEvent");

	callback.add(CallbackMSGDamagedTeam, "ZKE.damagedTeam");
	callback.add(CallbackMSGDamagedByTeam, "ZKE.damagedByTeam");

	callback.add(CallbackMSGGenDes, "ZKE.destroyed");
	callback.add(CallbackMSGSolarDes, "ZKE.destroyed");
	callback.add(CallbackMSGInvDes, "ZKE.destroyed");
	callback.add(CallbackMSGSensorDes, "ZKE.destroyed");
	callback.add(CallbackMSGTurretDes, "ZKE.destroyed");
	callback.add(CallbackMSGSentryDes, "ZKE.destroyed");
	callback.add(CallbackMSGVSDes, "ZKE.destroyed");
	callback.add(CallbackMSGDepSensorDes, "ZKE.destroyed");
	callback.add(CallbackMSGDepTurDes, "ZKE.destroyed");
	callback.add(CallbackMSGDepInvDes, "ZKE.destroyed");

	new AudioProfile(playOnDestroy)
	{
		filename	= "Zeph/destroyed.wav";
		description	= "audioGui";
		preload		= true;
	};

	new AudioProfile(playOnKill)
	{
		filename	= "Zeph/kill.wav";
		description	= "audioGui";
		preload		= true;
	};

	new AudioProfile(playOnTK)
	{
		filename	= "Zeph/tk.wav";
		description	= "audioGui";
		preload		= true;
	};

	new AudioProfile(playOnTKed)
	{
		filename	= "Zeph/tked.wav";
		description	= "audioGui";
		preload		= true;
	};

	new AudioProfile(playOnDamagedByTeam)
	{
		filename	= "Zeph/damagedByTeam.wav";
		description	= "audioGui";
		preload		= true;
	};

	new AudioProfile(playOnDamagedTeam)
	{
		filename	= "Zeph/damagedTeam.wav";
		description	= "audioGui";
		preload		= true;
	};

	new AudioProfile(playOnheadshotKill)
	{
		filename	= "Zeph/headshot.wav";
		description	= "audioGui";
		preload		= true;
	};

	new AudioProfile(playOnrearshotKill)
	{
		filename	= "Zeph/rearshot.wav";
		description	= "audioGui";
		preload		= true;
	};

	if(isObject(KillEventHUD)) return;

	new GuiControlProfile ("ZKE_Profile") 
	{
		fontType = "Arial";
		fontSize = 14;
	};

	%HudXpos = getWord(outerChatHud.position, 0);
	%HudYpos = getWord(outerChatHud.position, 1) + getWord(outerChatHud.extent, 1) + 4;
 
	%HudXext = 450;
	%HudYext = 92;

	new ShellFieldCtrl(KillEventHUD)
	{
		profile = "GuiChatBackProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = %HudXpos SPC %HudYpos;
		extent = %HudXext SPC %HudYext;
		minExtent = "8 8";
		visible = "0";

		new GuiMLTextCtrl(KillEventList) 
		{
				profile = "ZKE_Profile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "4 4";
				extent = %HudXext SPC %HudYext;
				minExtent = "8 8";
				visible = "1";
				helpTag = "0";
				lineSpacing = "0";
				allowColorChars = "1";
				maxChars = "-1";
		};
	};
	playGui.add(KillEventHUD);
	if(isObject(HM) && isObject(HudMover)) hudmover::addhud(KillEventHUD, "ZephKillHUD");
}

function ZKE::KillEvent(%this, %type, %killer, %victim, %weapon, %i_die, %i_win, %suicide, %tk)
{
	if($ZKEkillerName $= teamTracker.myName || $ZKEvictimName $= teamTracker.myName) %color = "<spush><color:af7d32>";
	else if(teamTracker.getPlayerTeamID($ZKEkillerName, 1) $= teamTracker.friendlyTeamID) %color = "<spush><color:00c800>";
	else %color = "<spush><color:c80000>";

	%ZKEkName = stripColor($ZKEkillerName);
	%ZKEvName = stripColor($ZKEvictimName);

	if(%type $= "MsgLegitKill" || %type $= "MsgRearshotKill" || %type $= "msgCTurretKill" || %type $= "MsgHeadshotKill")
	{
		%msg = %color @ %ZKEkName @ " killed " @ %ZKEvName @ " with a " @ %weapon @ ".<spop>";

		if(%i_win) alxPlay(playOnKill, 0, 0, 0);
		if(%i_win && %type $= "MsgRearshotkill") schedule(250, 0, alxPlay(playonrearshotKill, 0, 0, 0));
		if(%i_win && %type $= "MsgHeadshotKill") schedule(250, 0, alxPlay(playonheadshotKill, 0, 0, 0));
	}

	else if(%type $= "MsgRogueMineKill" || %type $= "msgCampKill" || %type $= "msgLavaKill" || %type $= "msgLightningKill" || %type $= "msgOOBKill" || %type $= "msgVehicleSpawnKill") %msg = %color @ %ZKEvName @ " killed by an act of God.";

	else if(%type $= "msgSelfKill" || %type $= "msgSuicide" || %type $= "msgTurretSelfKill") %msg = %color @ %ZKEvName @ " killed " @ $ZKEgender @ "self.<spop>";

	else if(%type $= "msgTeamKill")
	{
		%msg = %color @ %ZKEkName @ " <spush><color:ff0000>TEAMKILLED<spop> " @ %ZKEvName @ " with a " @ %weapon @ ".<spop>";

		if(%i_win)
		{
			alxPlay(playOnTK, 0, 0, 0);
			commandToServer('TeamMessageSent', "Sorry " @ $ZKEvictimName @ "!!!~wvqk.sorry");
		}

		if(%i_die)
		{
			alxPlay(playOnTKed, 0, 0, 0);
			commandToServer('TeamMessageSent', "Watch where you're shooting " @ $ZKEkillerName @ "!!!~wwrn.watchit");
		}
	}

	else if(%type $= "msgTurretKill") %msg = %color @ %ZKEvName @ " killed by a turret.<spop>";

	else if(%type $= "msgExplosionKill") %msg = %color @ %ZKEvName @ " killed by a nearby explosion.<spop>";

	else if(%type $= "msgVehicleKill")
	{
		if(teamTracker.getPlayerTeamID($ZKEkillerName, 0) == teamTracker.getPlayerTeamID($ZKEvictimName, 0))
		{
			%msg = %color @ %ZKEkName @ " <spush><color:ff0000>TEAMKILLED<spop> " @ %ZKEvName @ " by " @ %weapon @ ".<spop>";

			if(%i_win)
			{
				alxPlay(playOnTK, 0, 0, 0);
				commandToServer('TeamMessageSent', "Sorry " @ %ZKEvName @ "!!!~wvqk.sorry");
			}
		}
		else
		{
			%msg = %color @ %ZKEkName @ " killed " @ %ZKEvName @ " by " @ %weapon @ ".<spop>";

			if(%i_win)
			{
				alxPlay(playOnKill, 0, 0, 0);
			}
		}
	}

	else if(%weapon $= "default") return mute;

	%this.addHudLine(%msg);
	KillEventHUD.setVisible(1);
	if(isEventPending($KillEventHUD)) cancel($KillEventHUD);
	$KillEventHUD = KillEventHUD.schedule(7000, setVisible, 0);
	return mute;
}

function ZKE::destroyed(%this, %msgType, %msgString, %dest) // Handles you destroying NME shit.
{
	%dest = deTag(%dest);

	switch$(detag(%msgType))
	{
		case MsgDepTurDes:		if(Strstr(%string, "spider") !$= -1) %dest = "a deployable clamp turret";
						else %dest = "a deployable spike turret";
		case MsgDepInvDes:		%dest = "an inventory station";
		case MsgDepSensorDes:		%dest = "a deployable sensor";
		case msgGenDes:			%dest = "a generator";
		case msgTurretDes:		%dest = "a turret";
		case msgSensorDes:		%dest = "a sensor";
		case msgVSDes:			%dest = "a vehicle station";
		case msgSolarDes:		%dest = "a solar panel";
		case msgSentryDes:		%dest = "a sentry turret";
		case msgInvDes:			%dest = "an inventory station";
		case msgMPBTeleDes:		%dest = "a MPB teleport station";
		default:			%dest = "a " @ %dest;
	}

	%color = "<color:af7d32>";

	%name = stripColor(teamTracker.myName);

	%msg = %color @ %name @ " destroyed " @ %dest @ ".<spop>";

	alxPlay(playOnDestroy, 0, 0, 0);

	%this.addHudLine(%msg);
	KillEventHUD.setVisible(1);
	if(isEventPending($KillEventHUD)) cancel($KillEventHUD);
	$KillEventHUD = KillEventHUD.schedule(7000, setVisible, 0);
	return mute;
}

function ZKE::VDestroyed(%this, %msgType, %msgString, %destroyerName, %vehicle) // Handles NME destroying your vehicles.
{
	%color = "<color:c80000>";

	%destroyerName = stripColor(%destroyerName);

	%msg = %color @ %destroyerName @ " destroyed a " @ %vehicle @ ".<spop>";

	%this.addHudLine(%msg);
	KillEventHUD.setVisible(1);
	if(isEventPending($KillEventHUD)) cancel($KillEventHUD);
	$KillEventHUD = KillEventHUD.schedule(7000, setVisible, 0);
	return mute;
}

function ZKE::TKVDestroyed(%this, %msgType, %msgString, %destroyerName, %vehicle) // Handles everyone TKing vehicles.
{
	%destroyerName = deTag(%destroyerName);

	if(%destroyerName $= teamTracker.myName)
	{
		%color = "<color:af7d32>";
		alxPlay(playOnDestroy, 0, 0, 0);
		alxPlay(playOnTK, 0, 0, 0);
	}
	else if(teamTracker.getPlayerTeamID(%destroyerName,1) $= teamTracker.friendlyTeamID) %color = "<color:00c800>";
	else %color = "<color:c80000>";

	%destroyerName = stripColor(%destroyerName);
	
	%msg = %color @ %destroyerName @ " <spush><color:ff0000>TEAMDESTROYED<spop> a " @ $ZKEgender @ ".<spop>";

	%this.addHudLine(%msg);
	KillEventHUD.setVisible(1);
	if(isEventPending($KillEventHUD)) cancel($KillEventHUD);
	$KillEventHUD = KillEventHUD.schedule(7000, setVisible, 0);
	return mute;
}

function ZKE::VScore(%this, %msgType, %msgString, %score, %vehicle) // Handles you destroying NME vehicles.
{
	%color = "<color:af7d32>";

	%name = stripColor(teamTracker.myName);
	%dest = stripColor($ZKEgender);

	%msg = %color @ %name @ " destroyed " @ %dest @ ".<spop>";

	alxPlay(playOnDestroy, 0, 0, 0);

	%this.addHudLine(%msg);
	KillEventHUD.setVisible(1);
	if(isEventPending($KillEventHUD)) cancel($KillEventHUD);
	$KillEventHUD = KillEventHUD.schedule(7000, setVisible, 0);
	return mute;
}

function ZKE::VCrash(%this, %msgType, %msgString, %vName, %vGender, %vPoss, %kName, %kGender, %kPoss, %damageType) // Handles everyone killing themselves in vehicle crashes.
{
	%vName = deTag(%vName);

	if(%vName $= teamTracker.myName)
	{
		%color = "<color:af7d32>";
		alxPlay(playOnDestroy, 0, 0, 0);
		alxPlay(playOnTK, 0, 0, 0);
	}
	else if(teamTracker.getPlayerTeamID(%vName,1) $= teamTracker.friendlyTeamID) %color = "<color:00c800>";
	else %color = "<color:c80000>";

	%vName = stripColor(%vName);
	
	%msg = %color @ %vName @ " dies in a vehicle explosion.<spop>";

	%this.addHudLine(%msg);
	KillEventHUD.setVisible(1);
	if(isEventPending($KillEventHUD)) cancel($KillEventHUD);
	$KillEventHUD = KillEventHUD.schedule(7000, setVisible, 0);
	return mute;
}

function ZKE::damagedTeam(%this, %msgType, %msgString, %name)
{
	%gameType = MissionCallback.getMissionType();
	if(%gameType $= "LakRabbit") return;

	%player = stripColor(%name);

	%msg = "<spush><color:af7d32>You accidently hit<spop><spush><color:00c800> " @ %player @ ".<spop>";
	alxPlay(playOnDamagedTeam, 0, 0, 0);

	%this.addHudLine(%msg);
	KillEventHUD.setVisible(1);
	if(isEventPending($KillEventHUD)) cancel($KillEventHUD);
	$KillEventHUD = KillEventHUD.schedule(7000, setVisible, 0);
	return mute;
}

function ZKE::damagedByTeam(%this, %msgType, %msgString, %name)
{
	%gameType = MissionCallback.getMissionType();
	if(%gameType $= "LakRabbit") return;

	%player = stripColor(%name);

	%msg = "<spush><color:af7d32>You were hit by<spop><spush><color:00c800> " @ %player @ ".<spop>";
	alxPlay(playOnDamagedByTeam, 0, 0, 0);

	%this.addHudLine(%msg);
	KillEventHUD.setVisible(1);
	if(isEventPending($KillEventHUD)) cancel($KillEventHUD);
	$KillEventHUD = KillEventHUD.schedule(7000, setVisible, 0);
	return mute;
}

function ZKE::clearHudInfo(%this)
{
	$Hudline[1] = "";
	$Hudline[2] = "";
	$Hudline[3] = "";
	$Hudline[4] = "";
	$Hudline[5] = "";
	$Hudline[6] = "";
	%this.addHudLine(%null);
	if($ClearHudSchedule !$= "") cancel($ClearHudSchedule);
}

function ZKE::addHudLine(%this, %text)
{
	if($ClearHudSchedule !$= "") cancel($ClearHudSchedule);
	$Hudline[1] = $Hudline[2];
	$Hudline[2] = $Hudline[3];
	$Hudline[3] = $Hudline[4];
	$Hudline[4] = $Hudline[5];
	$Hudline[5] = $Hudline[6];
	$Hudline[6] = %text;
	KillEventList.setText($Hudline[1] @ "\n" @
				 $Hudline[2] @ "\n" @
				 $Hudline[3] @ "\n" @
				 $Hudline[4] @ "\n" @
				 $Hudline[5] @ "\n" @
				 $Hudline[6] @ "\n");
	$ClearHudSchedule = schedule(5000, 0, %this.clearHudInfo);
}

function ZKE::loadPrefs()
{
	if(!$ZKE::loaded)
	{
		exec("prefs/ZKE_Prefs.cs");
		$ZKE::loaded = 1;
	}
}

function ZKE::savePrefs()
{
	export("$ZKE::*", "prefs/ZKE_Prefs.cs", false);
}

ZKE.loadPrefs();
ZKE.setup();